
;      --==7G==--  v3.0
;        BOB the CAT
;
;          |\___/|  ('
;          ( O O )   )
;     --oOo------oOo---
;     bob.cat@wanadoo.fr
;
; 83 (SOS) Port By Jacob Boyce
; E-Mail: Sk0g@mindless.com
; Sk0gGiE on IRC, 2140141 on ICQ
;
; 83/83+ (ION/MirageOS)
; Ports By Jason Kovacs
; E-Mail: Jason_K@calc.org
; Jason_K on IRC, 27144093 on ICQ 

#include "ti83plus.inc"
#include "mirage.inc"

top         = saferam1+0
bot         = saferam1+2
Shipy       = saferam1+4
Score       = saferam1+8
Minefactor  = saferam1+10
Speed       = saferam1+14
string      = saferam1+20
Highscore   = saferam1+12

	.org $9d93
	.db $BB,$6D
	ret
	.db 1
Button:
	.db %00000000,%00000000
	.db %01111110,%01111000
	.db %01111110,%11111100
	.db %00001110,%11000000
	.db %00011100,%11001100
	.db %00111000,%11111100
	.db %00110000,%01111000
	.db %00000000,%00000000
	.db %00000000,%10000000
	.db %01101101,%11110000
	.db %00000000,%11111100
	.db %01101101,%11110000
	.db %00000000,%10000000
	.db %00000000,%00000000
	.db %00000000,%00000000
Description:
	.db "--==7G==-- v3.0", 0

start:
	RES textEraseBelow,(IY+textFlags)
	SET textInverse, (IY+textFlags)
	SET textwrite, (IY+sgrflags)
	ld hl, TitlePic
	ld de, Plotsscreen
	call DispRLE
	ld de, $361B
	ld hl, ClearStr
	call setvputs
	ld de, $161F
	ld hl, Choice2
	call setvputs
	ld de, $1E21
	ld hl, Choice3
	call setvputs
	ld de, $2609
	ld hl, SOS_Port
	call setvputs
	ld de, $2D08
	ld hl, ION_Port
	call setvputs
	call fastcopy
	RES textInverse, (IY+textFlags)
	RES textwrite, (IY+sgrflags)
SetChoice1:
	bcall(_getcsc)
	cp $22
	jr z, SetSpeed1
	cp $1A
	jr z, SetSpeed2
	cp $12
	jr z, SetSpeed3
	cp $23
	jr z, SetSpeed4
	cp $1B
	jr z, SetSpeed5
	cp $0F
	ret z
	jr SetChoice1
SetSpeed1:
;	ld hl, 0000
	ld a, 5
	jr PutChoice2
SetSpeed2:
;	ld hl, 1000
	ld a, 4
	jr PutChoice2
SetSpeed3:
;	ld hl, 2000
	ld a, 3
	jr PutChoice2
SetSpeed4:
;	ld hl,3000
	ld a, 2
	jr PutChoice2
SetSpeed5:
;	ld hl,4000
	ld a, 1
PutChoice2:
;	ld (Speed), hl
	ld (Speed), a
	SET textInverse, (IY+textFlags)
	ld de, $1619
	ld hl, Choice1
	call setvputs
	RES textInverse, (IY+textFlags)
SetChoice2:
	bcall(_getcsc)
	cp $22
	jr z, SetDif1
	cp $1A
	jr z, SetDif2
	cp $12
	jr z, SetDif3
	cp $23
	jr z, SetDif4
	cp $1B
	jr z, SetDif5
	cp $0F
	ret z
	jr SetChoice2
SetDif1:
	xor a
	jr EndChoice
SetDif2:
	ld a, 10
	jr EndChoice
SetDif3:
	ld a, 20
	jr EndChoice
SetDif4:
	ld a, 40
	jr EndChoice
SetDif5:
	ld a, 128
EndChoice:
	ld (Minefactor), a
	ld hl, 16			;Set top and bottom of the cave
	ld (top), hl
	ld hl, 20
	ld (bot), hl

	ld hl, StartPic			;Display start screen
	ld de, Plotsscreen
	call DispRLE
	ld a, 29
	ld (Shipy), a
	call PutSpr
	call fastcopy

Wait1:					;Wait for RIGHT to start
	ld hl, $0000
	ld (Score), hl
	bcall(_getcsc)
	cp $0F
	ret z
	cp $03
	jr nz, Wait1

Main:
	call Scroll			;call the scrolling routine
	call RAND			;randomize the top and
	cp 63				;bottom of the cave
	call c, Topinc
	call nc, Topdec
	call RAND
	cp 63
	call c, Botinc
	call nc, Botdec

	call PutSpr			;Set all sprites
	call putspr1
	call Putsmoke
	ld a, (Minefactor)
	or a
	call nz, Mine
	call fastcopy
	
	ld a, (Speed)
	ld b, a
	call DelayB
	
;	or a
;	call nz,Delay			;Speed setting

	ld b, $FD
	call Direct_Input
	BIT 6, A
	RET Z
	ld b, $FE
	call Direct_Input
	BIT 0, A
	CALL Z, Down
	BIT 3, A
	CALL Z, Up

Hittest:				;"Hit anything" routine
	ld b, 25
	ld a, (ShipY)
	call Hit
	ld b, 25
	ld a, (ShipY)
	add a, 4
	call Hit
	ld b, 31
	ld a, (ShipY)
	inc a
	inc a
	call Hit
	ld b, 25
	ld a, (ShipY)
	inc a
	inc a
	call Hit
	jr z,Lose
	jr Main

Direct_Input:
	ld a, $FF
	out (1), a
	ld a, b
	out (1), a
	in a, (1)
	ret

;Delay:					;Speed settings
;	LD  hl,(Speed)
;DelayLoop:
;	DEC hl
;	LD  A, h
;	OR  l
;	JR  NZ, DelayLoop
;	RET

Lose:
	SET textEraseBelow,(IY+textFlags)
	ld de, $0202
	ld hl, Youlose
	call setvputs
	ld hl, Scorestr
	ld de, $0A02
	call setvputs
	ld de, $0A1D
	ld hl, (Score)
	call DispHL
	call Highupdate
	ld hl, Highstr
	ld de, $1202
	call setvputs
	ld hl, (Highscore)
	ld de, $122A
	call DispHL
Keywait:
	bcall(_getkey)
	cp $01
	jr z, Keywait
	cp $03
	jr z, Keywait
	cp $04
	jr z, Keywait
	jp start

Hit:
	LD  C,A
	LD  A, B                      
	LD  B, 0
	LD  H, B
	LD  L, C
	ADD HL, HL
	ADD HL, BC
	ADD HL, HL
	ADD HL, HL
	LD  C, A
	SRL C
	SRL C
	SRL C
	ADD HL, BC
	LD  BC, Plotsscreen
	ADD HL, BC
	LD  B, %10000000
	AND %00000111
	JR  Z, Hitdone
	LD  C, A
	LD  A, B
	LD  B, C
ShloopGetPix:
	RRA
	DJNZ ShloopGetPix
	LD  B, A
Hitdone:
	LD  A, (HL)
	AND B
	RET

Scroll:
	ld hl, (Score)
	inc hl
	ld (Score), hl
	ld a, 8
Scrollloop:
	call Scrollscr
	dec a
	jr nz, Scrollloop
	ret
Scrollscr:           
	LD  HL, Plotsscreen+767         
	LD  B, 64
_LLoop:
	SLA (HL)                      
	DEC HL
_DECHL:
	RL  (HL)
	DEC HL
	RL  (HL)
	DEC HL
	RL  (HL)
	DEC HL
	RL  (HL)
	DEC HL
	RL  (HL)
	DEC HL
	RL  (HL)
	DEC HL
	RL  (HL)
	DEC HL
	RL  (HL)
	DEC HL
	RL  (HL)
	DEC HL
	RL  (HL)
	DEC HL
	RL  (HL)
	DEC HL
	DJNZ _LLoop
	ret

Topinc:
	ld a,(top)
	cp 40
	jr z,Toploop
	inc a
	ld (top),a
	jr Toploop
	ld hl, Plotsscreen+11
Topdec:
	ld a,(top)
	cp 2
	jr z,Toploop
	dec a
	ld (top),a
	ld hl, Plotsscreen+11
Toploop:
	ld c, $FF
	ld (hl), c
	ld b, 12
Toploopinc:
	inc hl
	dec b
	jr nz, Toploopinc
	dec a
	jr nz, Toploop
	ret

Botinc:
	ld c, $FF
	ld hl, Plotsscreen+767
	ld de, (bot)
	ld a, e
	cp 40
	jr z, Botloop
	xor a
	add a, e
	ld de, (top)
	add a, e
	cp 50
	jr nc, Botdec
	ld de, (bot)
	inc de
	ld (bot), de
	ld a, e
	jr Botloop
Botdec:
	ld c, $FF
	ld hl, Plotsscreen+767
	ld a, (bot)
	cp 2
	jr z, Botloop
	dec a
	ld (bot), a
Botloop:
	ld (hl), c
	ld b, 12
Botloopinc:
	dec hl
	dec b
	jr nz, Botloopinc
	dec a
	jr nz, Botloop
	ret
Up:
	ld a, (ShipY)
	dec a
	dec a
	ld (ShipY), a
	ret
Down:
	ld hl, (ShipY)	;doesn't work with the accumulator for some reason
	inc hl
	inc hl
	ld (ShipY), hl
Endmine:		;saves a byte or two this way
	ret

Putsmoke:
	ld b,6
	ld a, (ShipY)
	dec a
	dec a
	ld l, a
	ld a, 16
	ld ix, Smoke
	jr putsprclp

PutSpr1:
	ld b,5
	ld a, (ShipY)
	ld l, a
	ld a, 16
	ld ix, ship
	jr putsprclp
PutSpr:
	ld b, 5
	ld a, (ShipY)
	ld l, a
	ld a, 24
	ld ix, ship

PutSprClp:
	PUSH AF
	PUSH BC
	PUSH DE
	PUSH HL
	call SmallSprite
	POP HL
	POP DE
	POP BC
	POP AF
	ret

Mine:
	ld bc, (Minefactor)
	call RAND
	cp c
	jr nc, Endmine
	xor a
	ld de, (top)
	add a, e
	ld de, (bot)
	add a, e
	cp 25
	jr nc, Endmine
	ld a, 59
	sub e
	ld c, a
Randmine:
	call RAND
	cp c
	jr nc, Randmine
	ld de, (top)
	cp e
	jr c, Randmine	
	ld l, a
	ld a, 88
	ld b, 5
	ld ix, Minespr
	jr PutSprClp

Highupdate:
	ld hl, (score)
	push hl
	ld a, (Minefactor)
	or a
	jr z, Hightooeasy
	cp 10
	jr z, Higheasy
	cp 20
	jr z, Highnormal
	cp 40
	jr z, Highhard
	cp 128
	jr z, Highimp
Hightooeasy:
	ld de, (Hightooeasynb)
	bcall(_cphlde)
	jr nc, Hightooeasyupd
	ld hl, (Hightooeasynb)
	ld (Highscore),hl
	pop hl
	ret
Hightooeasyupd:
	pop hl
	ld (Hightooeasynb), hl
	ld (Highscore), hl
	ret
Higheasy:
	ld de, (Higheasynb)
	bcall(_cphlde)
	jr nc, Higheasyupd
	ld hl, (Higheasynb)
	ld (Highscore), hl
	pop hl
	ret
Higheasyupd:
	pop hl
	ld (Higheasynb), hl
	ld (Highscore), hl
	ret
Highnormal:
	ld de, (Highnormalnb)
	bcall(_cphlde)
	jr nc, Highnormalupd
	ld hl, (Highnormalnb)
	ld (Highscore), hl
	pop hl
	ret
Highnormalupd:
	pop hl
	ld (Highnormalnb), hl
	ld (Highscore), hl
	ret
Highhard:
	ld de, (Highhardnb)
	bcall(_cphlde)
	jr nc, Highhardupd
	ld hl, (Highhardnb)
	ld (Highscore), hl
	pop hl
	ret
Highhardupd:
	pop hl
	ld (Highhardnb), hl
	ld (Highscore), hl
	ret
Highimp:
	ld de, (Highimpnb)
	bcall(_cphlde)
	jr nc, Highimpupd
	ld hl, (Highimpnb)
	ld (Highscore), hl
	pop hl
	ret
Highimpupd:
	pop hl
	ld (Highimpnb), hl
	ld (Highscore), hl
	ret

DispHL:
	bcall(_setxxxxop2)
	bcall(_op2toop1)
	ld a, 4
	bcall(_dispop1a) 
	ret

RAND:
	ld b,128
	jp iRandom

StartPic:
	.db $91,$00,$09,$03,$FF,$FF,$91,$00,$09,$03,$FF,$FF
	.db $91,$00,$09,$03,$FF,$FF,$91,$00,$09,$03,$FF,$FF
	.db $91,$00,$09,$01,$FF,$FF,$91,$00,$09,$01,$FF,$FF
	.db $91,$00,$09,$03,$FF,$FF,$91,$00,$09,$03,$FF,$FF
	.db $91,$00,$09,$03,$FF,$FF,$91,$00,$09,$03,$FF,$FF
	.db $91,$00,$09,$03,$FF,$FF,$91,$00,$09,$03,$FF,$FF
	.db $91,$00,$09,$03,$91,$FF,$03,$80,$91,$00,$07,$01
	.db $FF,$FF,$00,$7F,$FF,$FE,$91,$00,$07,$FF,$91,$00
	.db $03,$01,$80,$91,$00,$07,$3F,$FE,$00,$00,$40,$91
	.db $00,$07,$3E,$02,$A6,$4E,$20,$91,$00,$07,$3F,$FE
	.db $A8,$A8,$1E,$91,$00,$07,$3E,$02,$A4,$EC,$01,$80
	.db $91,$00,$06,$3F,$FE,$A2,$A8,$02,$40,$91,$00,$06
	.db $20,$02,$EC,$A8,$02,$20,$91,$00,$06,$3F,$FE,$00
	.db $00,$02,$A0,$91,$00,$0A,$02,$A0,$91,$00,$06,$91
	.db $FF,$05,$90,$91,$00,$0B,$10,$91,$00,$06,$91,$FF
	.db $05,$F0,$91,$00,$1F,$80,$91,$00,$0A,$21,$F0,$10
	.db $91,$00,$09,$10,$FE,$08,$91,$00,$09,$29,$F8,$14
	.db $91,$00,$09,$44,$C0,$22,$91,$00,$09,$91,$FF,$05
	.db $E0,$91,$00,$0B,$20,$91,$00,$06,$F7,$FF,$FF,$F9
	.db $FF,$E0,$91,$00,$06,$14,$00,$00,$12,$00,$20,$91
	.db $00,$06,$15,$F7,$DA,$A4,$07,$C0,$91,$00,$06,$15
	.db $6C,$35,$48,$08,$91,$00,$07,$14,$DB,$6A,$90,$08
	.db $91,$00,$07,$15,$BE,$D5,$20,$08,$91,$00,$07,$14
	.db $00,$02,$40,$08,$91,$00,$07,$F7,$FF,$FC,$FF,$F8
	.db $91,$00,$05,$3E,$3F,$91,$00,$04,$20,$91,$00,$05
	.db $91,$FF,$06,$E0,$91,$00,$05,$FF,$FF,$91,$00,$03
	.db $40,$91,$00,$05,$01,$91,$FF,$04,$FC,$40,$91,$00
	.db $05,$01,$FF,$FF,$91,$00,$03,$40,$91,$00,$05,$01
	.db $FF,$FF,$91,$00,$03,$80,$91,$00,$05,$03,$91,$FF
	.db $04,$F0,$80,$91,$00,$05,$03,$FF,$FF,$00,$00,$01
	.db $91,$00,$06,$03,$FF,$FF,$00,$00,$06,$91,$00,$06
	.db $03,$91,$FF,$03,$E0,$38,$91,$00,$06,$03,$FF,$FF
	.db $00,$1F,$C0,$91,$00,$06,$01,$FF,$FF,$91,$00,$09
	.db $01,$FF,$FF,$91,$00,$09,$01,$FF,$FF,$91,$00,$09
	.db $01,$FF,$FF,$91,$00,$09,$01,$FF,$FF,$91,$00,$09
	.db $03,$FF,$FF,$91,$00,$09,$03,$FF,$FF,$91,$00,$09
	.db $03,$FF,$FF,$91,$00,$09,$03,$FF,$FF,$91,$00,$0C

TitlePic:
	.db $91,$FF,$0C,$91,$00,$0C,$FD,$91,$FF,$05,$F9,$91
	.db $FF,$05,$05,$91,$00,$05,$09,$91,$00,$05,$05,$7F
	.db $F3,$FF,$CF,$76,$92,$5B,$BD,$91,$FF,$03,$05,$7F
	.db $F3,$FF,$CF,$76,$92,$5B,$BD,$91,$FF,$03,$05,$7D
	.db $E7,$80,$1E,$ED,$24,$B7,$7B,$FF,$F9,$FB,$05,$7D
	.db $E7,$80,$1E,$ED,$24,$B7,$7B,$FF,$FA,$F5,$05,$7B
	.db $CF,$00,$3D,$DA,$49,$6E,$F7,$FF,$FA,$B7,$05,$7B
	.db $CF,$00,$3D,$DA,$49,$6E,$F7,$CF,$BA,$97,$05,$07
	.db $9E,$FE,$7B,$B4,$92,$DD,$EF,$F7,$59,$B7,$05,$07
	.db $9E,$FE,$7B,$B4,$92,$DD,$ED,$6F,$5A,$B7,$05,$0F
	.db $3D,$FC,$F7,$69,$25,$BB,$DD,$77,$5A,$B5,$05,$0F
	.db $3C,$3C,$F7,$69,$25,$BB,$DE,$CD,$B9,$DB,$05,$1E
	.db $7F,$F9,$EE,$D2,$4B,$77,$BF,$91,$FF,$03,$05,$1E
	.db $7F,$F9,$EE,$D2,$4B,$77,$BF,$91,$FF,$03,$05,$91
	.db $00,$04,$04,$80,$91,$00,$05,$FD,$91,$FF,$04,$FC
	.db $91,$FF,$06,$91,$00,$0C,$91,$FF,$FF,$91,$FF,$FF
	.db $91,$FF,$1E

Hightooeasynb:
	.dw	$0000
Higheasynb:
	.dw	$0000
Highnormalnb:
	.dw	$0000
Highhardnb:
	.dw	$0000
Highimpnb:
	.dw	$0000

Youlose:
	.db	" You lose!",0
Choice1:
	.db	"Set Difficulty",0
Choice2:
	.db	"Set Speed",0
Choice3:
	.db	"1",$CF,"-3-",$05,"5",0
ClearStr:
	.db	"CLEAR to Quit",0
Scorestr:
	.db	" Score:",0
Highstr:
	.db	" Highscore:",0
SOS_Port:
	.db	"S0S Port by Jacob Boyce",0
ION_Port:
	.db "Mirage0S Port by Jason K."
;	.db 0

Smoke:
	.db	%00000000
	.db	%00000000
	.db	%00000000
	.db	%10110110
	.db	%00000000
	.db	%11010110
Minespr:
	.db	%01011010
	.db	%00111100
	.db	%01111110
	.db	%00111100
	.db	%01011010
Ship:
	.db	%01000000
	.db	%11111000
	.db	%01111111
	.db	%11111100
	.db	%01100000

.end





